﻿using System;
using System.Windows.Forms;

namespace TestProject
{
    /// <summary>
    /// 메인 폼
    /// </summary>
    public partial class MainForm : Form
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainForm()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainForm()
        {
            InitializeComponent();

            #region 이벤트를 설정한다.

            Load                     += Form_Load;
            this.refreshButton.Click += refreshButton_Click;

            #endregion
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private
        //////////////////////////////////////////////////////////////////////////////// Event

        #region 폼 로드시 처리하기 - Form_Load(sender, e)

        /// <summary>
        /// 폼 로드시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void Form_Load(object sender, EventArgs e)
        {
            ShowPowerStatus();
        }

        #endregion
        #region 갱신하기 버튼 클릭시 처리하기 - refreshButton_Click(sender, e)

        /// <summary>
        /// 갱신하기 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void refreshButton_Click(object sender, EventArgs e)
        {
            ShowPowerStatus();
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////// Function

        #region 전원 상태 표시하기 - ShowPowerStatus()

        /// <summary>
        /// 전원 상태 표시하기
        /// </summary>
        private void ShowPowerStatus()
        {
            PowerStatus status = SystemInformation.PowerStatus;

            this.chargeStatusTextBox.Text = status.BatteryChargeStatus.ToString();

            if(status.BatteryFullLifetime == -1)
            {
                this.fullLifeTextBox.Text = "Unknown";
            }
            else
            {
                this.fullLifeTextBox.Text = status.BatteryFullLifetime.ToString();
            }

            this.chargeTextBox.Text = status.BatteryLifePercent.ToString("P0");

            if(status.BatteryLifeRemaining == -1)
            {
                this.lifeRemainingTextBox.Text = "Unknown";
            }
            else
            {
                this.lifeRemainingTextBox.Text = status.BatteryLifeRemaining.ToString();
            }

            this.lineStatusTextBox.Text = status.PowerLineStatus.ToString();
        }

        #endregion
    }
}